// LifeGame.h: CLifeGame NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIFEGAME_H__3010CFD7_37FA_4E7F_A6C7_A478E36F1BF5__INCLUDED_)
#define AFX_LIFEGAME_H__3010CFD7_37FA_4E7F_A6C7_A478E36F1BF5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ManagedArray.h"
typedef DWORD CLifeElem;

#define DEFAULT_WIDTH  64
#define DEFAULT_HEIGHT 64

class CLifeGame  
{
public:
  CLifeGame(unsigned long m_width = DEFAULT_WIDTH, unsigned long m_height = DEFAULT_HEIGHT);
  virtual ~CLifeGame();

protected:
  unsigned long m_width, m_height;
  CLifeElem *m_pBuffer[2];
  CLifeElem *m_pMap, *m_pTemp;
  
public:
  unsigned long GetWidth() const { return m_width; }
  unsigned long GetHeight() const { return m_height; }
  void Resize(unsigned long width, unsigned height);
public:
  BOOL IsCellSet(unsigned long x, unsigned long y) const;
  void SetCell(unsigned long x, unsigned long y, BOOL set);
  void MakeBits(void *pBuffer) const;
  void Next();
};

#define BITS_PER_CELL_LOG 2
#define BITS_PER_CELL     4
#define BITS_PER_ELEM_LOG 5
#define BITS_PER_ELEM     32

#endif // !defined(AFX_LIFEGAME_H__3010CFD7_37FA_4E7F_A6C7_A478E36F1BF5__INCLUDED_)
