// ChildView.h : CChildView NX̃C^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__9C836406_92F6_43AA_837B_D08582479D51__INCLUDED_)
#define AFX_CHILDVIEW_H__9C836406_92F6_43AA_837B_D08582479D51__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CChildView EBhE

#include "LifeGame.h"

class CChildView : public CWnd
{
// RXgN^
public:
  CChildView();

// Agr[g
private:
  CLifeGame *m_pLife;
  BYTE *m_pBits;
  CBitmap m_Bitmap;

// Iy[V
public:

// I[o[Ch
  // ClassWizard ͉z֐̃I[o[Ch𐶐܂B
  //{{AFX_VIRTUAL(CChildView)
  protected:
  virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
  //}}AFX_VIRTUAL

// Cve[V
public:
  static DWORD WINAPI GenerateThread(LPVOID lpvParam);
  virtual ~CChildView();

protected:
  HANDLE m_hEvent, m_hThread;

  volatile BOOL m_bPlaying;
  volatile DWORD m_dwGeneration;
  DWORD m_dwPrevTick, m_dwPrevGen, m_dwGPS;
  BOOL m_bIsSet, m_bIsDrawing;

  // ꂽbZ[W }bv֐
protected:
  void UpdateBitmap();
  BOOL DoResize();

  //{{AFX_MSG(CChildView)
  afx_msg void OnPaint();
  afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
  afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg void OnUpdatePlaybutton(CCmdUI* pCmdUI);
  afx_msg void OnPlaybutton();
  afx_msg void OnUpdateStepbutton(CCmdUI* pCmdUI);
  afx_msg void OnStepbutton();
  afx_msg void OnUpdateStopbutton(CCmdUI* pCmdUI);
  afx_msg void OnStopbutton();
  afx_msg void OnTimer(UINT nIDEvent);
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()

private:
  volatile DWORD m_dwSpinLock;

  inline void AcquireSpinLock() {
    register volatile DWORD *pdwSpinLock = &m_dwSpinLock;
    _asm {
      mov ebx, pdwSpinLock
      mov eax, 1
    spl_lp:
      xchg eax, dword ptr [ebx]
      or  eax, eax
      jnz spl_lp
    }
  }
  inline void ReleaseSpinLock() {
    m_dwSpinLock = 0UL;
  }
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ V`ꍇɂ́A̍sOɒǉ܂B

#endif // !defined(AFX_CHILDVIEW_H__9C836406_92F6_43AA_837B_D08582479D51__INCLUDED_)
